Package io.vertx.reactivex.grpc.client

## Class GrpcClientRequest<Req,​Resp>

- java.lang.Object
- - io.vertx.reactivex.grpc.common.GrpcWriteStream<Req>
  - - io.vertx.reactivex.grpc.client.GrpcClientRequest<Req,​Resp>

- All Implemented Interfaces:
    `io.vertx.lang.rx.RxDelegate`, `StreamBase`, `WriteStream<Req>`

      public class GrpcClientRequest<Req,​Resp>
      extends GrpcWriteStream<Req>
      implements io.vertx.lang.rx.RxDelegate

  A request to a gRPC server.

  You interact with the remote service with gRPC generated messages or protobuf encoded messages.

  Before sending a request you need to set `#serviceName)` and `#methodName)` or alternatively the service `fullMethodName(java.lang.String)`.

  Writing a request message will send the request to the service:

  - To send a unary request, just call
  - To send a streaming request, call any time you need and then `WriteStream.end()`

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static io.vertx.lang.rx.TypeArg<GrpcClientRequest>` | `__TYPE_ARG` |
    `io.vertx.lang.rx.TypeArg<Req>` | `__typeArg_0` |
    `io.vertx.lang.rx.TypeArg<Resp>` | `__typeArg_1` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `GrpcClientRequest​(GrpcClientRequest delegate)` |
    `GrpcClientRequest​(Object delegate, io.vertx.lang.rx.TypeArg<Req> typeArg_0, io.vertx.lang.rx.TypeArg<Resp> typeArg_1)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `HttpConnection` | `connection()` |
    `Timer` | `deadline()` |
    `GrpcClientRequest<Req,​Resp>` | `drainHandler​(Handler<Void> handler)` | Set a drain handler on the stream.
    `GrpcClientRequest<Req,​Resp>` | `encoding​(String encoding)` | Set the stream encoding, e.g.
    `Future<Void>` | `end()` | Ends the stream.
    `Future<Void>` | `end​(Req data)` | Same as `WriteStream.end()` but writes some data to the stream before ending.
    `boolean` | `equals​(Object o)` |
    `GrpcClientRequest<Req,​Resp>` | `exceptionHandler​(Handler<Throwable> handler)` | Set an exception handler on the write stream.
    `GrpcClientRequest<Req,​Resp>` | `format​(WireFormat format)` | Set the stream format, e.g.
    `GrpcClientRequest<Req,​Resp>` | `fullMethodName​(String fullMethodName)` | Set the full method name to call, it must follow the format `package-name + '.' + service-name + '/' + method-name` or an `IllegalArgumentException` is thrown.
    `GrpcClientRequest` | `getDelegate()` |
    `int` | `hashCode()` |
    `GrpcClientRequest<Req,​Resp>` | `idleTimeout​(long timeout)` | Sets the amount of time after which, if the request does not return any data within the timeout period, the request/response is cancelled and the related futures.
    `GrpcClientRequest<Req,​Resp>` | `methodName​(String methodName)` | Set the method name to call.
    `static <Req,​Resp> GrpcClientRequest<Req,​Resp>` | `newInstance​(GrpcClientRequest arg)` |
    `static <Req,​Resp> GrpcClientRequest<Req,​Resp>` | `newInstance​(GrpcClientRequest arg, io.vertx.lang.rx.TypeArg<Req> __typeArg_Req, io.vertx.lang.rx.TypeArg<Resp> __typeArg_Resp)` |
    `Future<GrpcClientResponse<Req,​Resp>>` | `response()` |
    `Completable` | `rxEnd()` | Ends the stream.
    `Completable` | `rxEnd​(Req data)` | Same as `WriteStream.end()` but writes some data to the stream before ending.
    `Single<GrpcClientResponse<Req,​Resp>>` | `rxResponse()` |
    `Single<GrpcClientResponse<Req,​Resp>>` | `rxSend​(Flowable<Req> body)` |
    `Single<GrpcClientResponse<Req,​Resp>>` | `rxSend​(ReadStream<Req> body)` |
    `Single<GrpcClientResponse<Req,​Resp>>` | `rxSend​(Req item)` |
    `Completable` | `rxWrite​(Req data)` | Write some data to the stream.
    `Future<GrpcClientResponse<Req,​Resp>>` | `send​(Flowable<Req> body)` |
    `Future<GrpcClientResponse<Req,​Resp>>` | `send​(ReadStream<Req> body)` |
    `Future<GrpcClientResponse<Req,​Resp>>` | `send​(Req item)` |
    `GrpcClientRequest<Req,​Resp>` | `serviceName​(ServiceName serviceName)` | Set the service name to call.
    `GrpcClientRequest<Req,​Resp>` | `setWriteQueueMaxSize​(int maxSize)` | Set the maximum size of the write queue to `maxSize`.
    `GrpcClientRequest<Req,​Resp>` | `timeout​(long timeout, TimeUnit unit)` | Set a `grpc-timeout` header to be sent to the server to indicate the client expects a response with a timeout.
    `WriteStreamObserver<Req>` | `toObserver()` |
    `String` | `toString()` |
    `WriteStreamSubscriber<Req>` | `toSubscriber()` |
    `Future<Void>` | `write​(Req data)` | Write some data to the stream.
    `boolean` | `writeQueueFull()` | This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`

    - ### Methods inherited from class io.vertx.reactivex.grpc.common.GrpcWriteStream

      `cancel, endMessage, headers, newInstance, newInstance, rxEndMessage, rxWriteMessage, writeMessage`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<GrpcClientRequest> __TYPE_ARG

    - #### __typeArg_0

          public final io.vertx.lang.rx.TypeArg<Req> __typeArg_0

    - #### __typeArg_1

          public final io.vertx.lang.rx.TypeArg<Resp> __typeArg_1

  - ### Constructor Detail

    - #### GrpcClientRequest

          public GrpcClientRequest​(GrpcClientRequest delegate)

    - #### GrpcClientRequest

          public GrpcClientRequest​(Object delegate,
                                   io.vertx.lang.rx.TypeArg<Req> typeArg_0,
                                   io.vertx.lang.rx.TypeArg<Resp> typeArg_1)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `GrpcWriteStream<Req>`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `GrpcWriteStream<Req>`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `GrpcWriteStream<Req>`

    - #### getDelegate

          public GrpcClientRequest getDelegate()

      Specified by:
        `getDelegate` in interface `io.vertx.lang.rx.RxDelegate`
      Specified by:
        `getDelegate` in interface `StreamBase`
      Specified by:
        `getDelegate` in interface `WriteStream<Req>`
      Overrides:
        `getDelegate` in class `GrpcWriteStream<Req>`

    - #### toObserver

          public WriteStreamObserver<Req> toObserver()

      Specified by:
        `toObserver` in interface `WriteStream<Req>`
      Overrides:
        `toObserver` in class `GrpcWriteStream<Req>`

    - #### toSubscriber

          public WriteStreamSubscriber<Req> toSubscriber()

      Specified by:
        `toSubscriber` in interface `WriteStream<Req>`
      Overrides:
        `toSubscriber` in class `GrpcWriteStream<Req>`

    - #### write

          public Future<Void> write​(Req data)

      Write some data to the stream.

      The data is usually put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a .

      When the `data` is moved from the queue to the actual medium, the returned will be completed with the write result, e.g the future is succeeded when a server HTTP response buffer is written to the socket and failed if the remote client has closed the socket while the data was still pending for write.

      Specified by:
        `write` in interface `WriteStream<Req>`
      Overrides:
        `write` in class `GrpcWriteStream<Req>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the write result

    - #### rxWrite

          public Completable rxWrite​(Req data)

      Write some data to the stream.

      The data is usually put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a .

      When the `data` is moved from the queue to the actual medium, the returned will be completed with the write result, e.g the future is succeeded when a server HTTP response buffer is written to the socket and failed if the remote client has closed the socket while the data was still pending for write.

      Specified by:
        `rxWrite` in interface `WriteStream<Req>`
      Overrides:
        `rxWrite` in class `GrpcWriteStream<Req>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the write result

    - #### end

          public Future<Void> end()

      Ends the stream.

      Once the stream has ended, it cannot be used any more.

      Specified by:
        `end` in interface `WriteStream<Req>`
      Overrides:
        `end` in class `GrpcWriteStream<Req>`
      Returns:
        a future completed with the result

    - #### rxEnd

          public Completable rxEnd()

      Ends the stream.

      Once the stream has ended, it cannot be used any more.

      Specified by:
        `rxEnd` in interface `WriteStream<Req>`
      Overrides:
        `rxEnd` in class `GrpcWriteStream<Req>`
      Returns:
        a future completed with the result

    - #### end

          public Future<Void> end​(Req data)

      Same as `WriteStream.end()` but writes some data to the stream before ending.
      Specified by:
        `end` in interface `WriteStream<Req>`
      Overrides:
        `end` in class `GrpcWriteStream<Req>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the result

    - #### rxEnd

          public Completable rxEnd​(Req data)

      Same as `WriteStream.end()` but writes some data to the stream before ending.
      Specified by:
        `rxEnd` in interface `WriteStream<Req>`
      Overrides:
        `rxEnd` in class `GrpcWriteStream<Req>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the result

    - #### writeQueueFull

          public boolean writeQueueFull()

      This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`
      Specified by:
        `writeQueueFull` in interface `WriteStream<Req>`
      Overrides:
        `writeQueueFull` in class `GrpcWriteStream<Req>`
      Returns:
        `true` if write queue is full

    - #### encoding

          public GrpcClientRequest<Req,​Resp> encoding​(String encoding)

      Description copied from class: `GrpcWriteStream`

      Set the stream encoding, e.g. `identity` or `gzip`,

      - The encoding must be set before sending any message, otherwise `identity` will be used.
      - The encoding should also match the opposite endpoint expectations.
      Overrides:
        `encoding` in class `GrpcWriteStream<Req>`
      Parameters:
        `encoding` - the target message encoding
      Returns:
        a reference to this, so the API can be used fluently

    - #### format

          public GrpcClientRequest<Req,​Resp> format​(WireFormat format)

      Description copied from class: `GrpcWriteStream`
      Set the stream format, e.g. `proto` or `json`. It must be called before sending any message, otherwise `proto` will be used.
      Overrides:
        `format` in class `GrpcWriteStream<Req>`
      Parameters:
        `format` - the message format
      Returns:
        a reference to this, so the API can be used fluently

    - #### fullMethodName

          public GrpcClientRequest<Req,​Resp> fullMethodName​(String fullMethodName)

      Set the full method name to call, it must follow the format `package-name + '.' + service-name + '/' + method-name` or an `IllegalArgumentException` is thrown.

      It must be called before sending the request otherwise an `IllegalStateException` is thrown.

      Parameters:
        `fullMethodName` - the full method name to call
      Returns:
        a reference to this, so the API can be used fluently

    - #### serviceName

          public GrpcClientRequest<Req,​Resp> serviceName​(ServiceName serviceName)

      Set the service name to call.

      It must be called before sending the request otherwise an `IllegalStateException` is thrown.

      Parameters:
        `serviceName` - the service name to call
      Returns:
        a reference to this, so the API can be used fluently

    - #### methodName

          public GrpcClientRequest<Req,​Resp> methodName​(String methodName)

      Set the method name to call.

      It must be called before sending the request otherwise an `IllegalStateException` is thrown.

      Parameters:
        `methodName` - the method name to call
      Returns:
        a reference to this, so the API can be used fluently

    - #### response

          public Future<GrpcClientResponse<Req,​Resp>> response()

      Returns:
        the gRPC response

    - #### rxResponse

          public Single<GrpcClientResponse<Req,​Resp>> rxResponse()

      Returns:
        the gRPC response

    - #### exceptionHandler

          public GrpcClientRequest<Req,​Resp> exceptionHandler​(Handler<Throwable> handler)

      Description copied from interface: `WriteStream`
      Set an exception handler on the write stream.
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Req>`
      Overrides:
        `exceptionHandler` in class `GrpcWriteStream<Req>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          public GrpcClientRequest<Req,​Resp> setWriteQueueMaxSize​(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pipe` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Req>`
      Overrides:
        `setWriteQueueMaxSize` in class `GrpcWriteStream<Req>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          public GrpcClientRequest<Req,​Resp> drainHandler​(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pipe` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.

      Specified by:
        `drainHandler` in interface `WriteStream<Req>`
      Overrides:
        `drainHandler` in class `GrpcWriteStream<Req>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### timeout

          public GrpcClientRequest<Req,​Resp> timeout​(long timeout,
                                                           TimeUnit unit)

      Set a `grpc-timeout` header to be sent to the server to indicate the client expects a response with a timeout.

      When the request handle deadline a timer will be set when sending the request to cancel the request when the response has not been received in time.

      Parameters:
        `timeout` -
        `unit` -
      Returns:

    - #### deadline

          public Timer deadline()

      Returns:
        the request deadline or `null` when no deadline has been scheduled

    - #### idleTimeout

          public GrpcClientRequest<Req,​Resp> idleTimeout​(long timeout)

      Sets the amount of time after which, if the request does not return any data within the timeout period, the request/response is cancelled and the related futures.
      Parameters:
        `timeout` - the amount of time in milliseconds.
      Returns:
        a reference to this, so the API can be used fluently

    - #### connection

          public HttpConnection connection()

      Returns:
        the underlying HTTP connection

    - #### send

          public Future<GrpcClientResponse<Req,​Resp>> send​(Req item)

    - #### rxSend

          public Single<GrpcClientResponse<Req,​Resp>> rxSend​(Req item)

    - #### send

          public Future<GrpcClientResponse<Req,​Resp>> send​(ReadStream<Req> body)

    - #### rxSend

          public Single<GrpcClientResponse<Req,​Resp>> rxSend​(ReadStream<Req> body)

    - #### send

          public Future<GrpcClientResponse<Req,​Resp>> send​(Flowable<Req> body)

    - #### rxSend

          public Single<GrpcClientResponse<Req,​Resp>> rxSend​(Flowable<Req> body)

    - #### newInstance

          public static <Req,​Resp> GrpcClientRequest<Req,​Resp> newInstance​(GrpcClientRequest arg)

    - #### newInstance

          public static <Req,​Resp> GrpcClientRequest<Req,​Resp> newInstance​(GrpcClientRequest arg,
                                                                                       io.vertx.lang.rx.TypeArg<Req> __typeArg_Req,
                                                                                       io.vertx.lang.rx.TypeArg<Resp> __typeArg_Resp)